
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include "initng_nge.h"
#include <initng_is.h>
#include <initng_system_states.h>
#include <initng_msg.h>
typedef struct s_nge_event nge_event;

struct s_nge_event
{
	/* functions that will be executed on data */
	void (*service_state_change) (nge_event * event, char *service, e_is is,
								  char *state_name);
	void (*system_state_change) (nge_event * event, h_sys_state state);
	void (*service_output) (nge_event * event, char *service, char *process,
							char *output);
	void (*err_msg) (nge_event * event, e_mt mt, char *file, char *func,
					 int line, char *message);
	void (*connect) (nge_event * event, int pver, char *initng_version);
	void (*disconnect) (nge_event * event);
	void (*ping) (nge_event * event);
	void (*initial_service_state) (nge_event * event, char *service, e_is is,
								   char *state_name);
	void (*initial_system_state) (nge_event * event, h_sys_state state);
	void (*initial_state_finished) (nge_event * event);

	/* standard variables to have */
	int sock;
	char *read_buffer;
	int read_buffer_len;

	/* user data variable, not used by initng itself */
	void *user_data;
};

extern const char *ngeclient_error;

int ngeclient_open_socket(nge_event * event, const char *path);
void ngeclient_close_socket(nge_event * event);
void ngeclient_free_buffer(nge_event * event);
int ngeclient_read_and_fill_buffer(nge_event * event);
int ngeclient_poll_for_input(nge_event * event, int seconds);
void ngeclient_cut_buffert(nge_event * event, int chars);
void ngeclient_parse_tags(nge_event * event);
void ngeclient_exec(nge_event * event);
